/*--------------------------------------------------------------- */

DROP PROCEDURE WYDRUK_RB28;

/*--------------------------------------------------------------- */

DROP TABLE FK_RAPORT; 

/*--------------------------------------------------------------- */


CREATE TABLE FK_RAPORT (
    ID                  INTEGER NOT NULL,
    ID_DOKUMENTU        INTEGER,
    ID_PARENT           INTEGER,
    ID_CHILD            INTEGER,
    DZIAL               CHAR(3),
    ROZDZIAL            CHAR(5),
    PAR                 CHAR(3),
    PAR4                CHAR(1),
    ID_ZADANIA          INTEGER,
    POZIOM              INTEGER,
    BUDZET              DOUBLE PRECISION,
    ZAANGAZOWANIE       DOUBLE PRECISION,
    ZOBOWIAZANIE        DOUBLE PRECISION,
    REALIZACJA          DOUBLE PRECISION,
    JEST_ZAANGAZOWANIE  CHAR(1)
);

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA,  :ZAANGAZOWANIE);
    end


    /*Zobowiazanie*/
    for select dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
     sum(dekr.KWOTA) as ZOBOWIAZANIE, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) = :ROK and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA, sdok.CZY_SAMODZIELNY
    into :ID_DOKUMENTU, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,  :ZOBOWIAZANIE, :CZY_SAMODZIELNY
    do
    begin
        /*Jesli dokument samodzielny to zbowiazanie  zawiera sie w  zaangazowaniu*/
        if (CZY_SAMODZIELNY= 'T') then ID_PARENT=:ID_DOKUMENTU;

        insert into FK_RAPORT(ID, ID_DOKUMENTU, ID_PARENT,  POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4, ID_ZADANIA, ZOBOWIAZANIE ) values
         (:ID, :ID_DOKUMENTU, :ID_PARENT,  2, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA, :ZOBOWIAZANIE);

    end

    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA,
    sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and sp.KOD='REALIZACJA' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end



    /* Wstawia zobowiazanie i realizacje do poziomu zaangazowania */
    for select rp.ID_PARENT,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum(rp.ZOBOWIAZANIE) as ZOBOWIAZANIE,   sum(rp.REALIZACJA) as REALIZACJA
    from  FK_RAPORT rp where rp.POZIOM=2 and rp.ID =:ID
    group by  rp.ID_PARENT, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZOBOWIAZANIE, :REALIZACJA
    do
    begin
        update FK_RAPORT set  ZOBOWIAZANIE= :ZOBOWIAZANIE, REALIZACJA=: REALIZACJA
        where  POZIOM=1 and ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end

    /*Usuwanie dodatkowych rekordw sumujcych*/
    delete from FK_RAPORT where ID=:ID and POZIOM=2;


    /*  Zwaraca ostateczne wyniki*/
    /*
	for select  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
	rp.ZAANGAZOWANIE, rp.ZOBOWIAZANIE, rp.REALIZACJA,
	sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY, sp.KOD as POZIOM
	from  FK_RAPORT rp
	join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
	join (
		select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
		from FK_DOKUMENTY d
		join FK_S_STATUSY s on d.STATUS = s.ID
		where s.CZY_USUNIETY = 'N'
		and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
		and d.DATA_DOK >= :DATAOD
		and d.DATA_DOK <= :DATADO
		group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
	join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
	join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
	left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
	left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
	where rp.POZIOM=1 and rp.ID =:ID
	order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
	into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,
	:ZAANGAZOWANIE, :ZOBOWIAZANIE, :REALIZACJA,:TYP, :PODTYP, :KONTRAHENT, :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM
	do
	begin
		suspend;
	end
    */

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT SELECT,INSERT,DELETE,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

/*--------------------------------------------------------------- */
SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/


    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4,  :ZAANGAZOWANIE);
    end


    /*Zobowiazanie*/
    for select dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
     sum(dekr.KWOTA) as ZOBOWIAZANIE, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) = :ROK and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, sdok.CZY_SAMODZIELNY
    into :ID_DOKUMENTU, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZOBOWIAZANIE, :CZY_SAMODZIELNY
    do
    begin
        /*Jesli dokument samodzielny to zbowiazanie  zawiera sie w  zaangazowaniu*/
        if (CZY_SAMODZIELNY= 'T') then ID_PARENT=:ID_DOKUMENTU;

        insert into FK_RAPORT(ID, ID_DOKUMENTU, ID_PARENT,  POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4,  ZOBOWIAZANIE ) values
         (:ID, :ID_DOKUMENTU, :ID_PARENT,  2, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ZOBOWIAZANIE);

    end

    /*Realizacja*/


    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and sp.KOD='REALIZACJA' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and PAR=:PAR and PAR4=:PAR4;
    end



    /* Wstawia zobowiazanie i realizacje do poziomu zaangazowania */
    for select rp.ID_PARENT,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4,
    sum(rp.ZOBOWIAZANIE) as ZOBOWIAZANIE,   sum(rp.REALIZACJA) as REALIZACJA
    from  FK_RAPORT rp where rp.POZIOM=2 and rp.ID =:ID
    group by  rp.ID_PARENT, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
    into  :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZOBOWIAZANIE, :REALIZACJA
    do
    begin
        update FK_RAPORT set  ZOBOWIAZANIE= :ZOBOWIAZANIE, REALIZACJA=: REALIZACJA
        where  POZIOM=1 and ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and PAR=:PAR and PAR4=:PAR4;
    end

    /*Usuwanie dodatkowych rekordw sumujcych*/
    delete from FK_RAPORT where ID=:ID and POZIOM=2;


    /*  Zwaraca ostateczne wyniki*/
    /*
	for select  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4,
	rp.ZAANGAZOWANIE, rp.ZOBOWIAZANIE, rp.REALIZACJA,
	sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY, sp.KOD as POZIOM
	from  FK_RAPORT rp
	join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
	join (
		select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
		from FK_DOKUMENTY d
		join FK_S_STATUSY s on d.STATUS = s.ID
		where s.CZY_USUNIETY = 'N'
		and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
		and d.DATA_DOK >= :DATAOD
		and d.DATA_DOK <= :DATADO
		group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
	join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
	join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
	left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
	left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
	where rp.POZIOM=1 and rp.ID =:ID
	order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
	into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4,
	:ZAANGAZOWANIE, :ZOBOWIAZANIE, :REALIZACJA,:TYP, :PODTYP, :KONTRAHENT, :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM
    do
    begin
       suspend;
    end

    */
	
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT SELECT,INSERT,DELETE,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP TO SYSDBA;


/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1),
    typ_pg varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA,  :ZAANGAZOWANIE);
    end


    /*Zobowiazanie*/
    for select dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
     sum(dekr.KWOTA) as ZOBOWIAZANIE, sdok.CZY_SAMODZIELNY
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on (ter.ID_DOKUMENTY = dok.ID)
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) = :ROK and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  dok.ID_PIERWOTNY, dok.ID_PARENT, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA, sdok.CZY_SAMODZIELNY
    into :ID_DOKUMENTU, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,  :ZOBOWIAZANIE, :CZY_SAMODZIELNY
    do
    begin
        /*Jesli dokument samodzielny to zbowiazanie  zawiera sie w  zaangazowaniu*/
        if (CZY_SAMODZIELNY= 'T') then ID_PARENT=:ID_DOKUMENTU;

        insert into FK_RAPORT(ID, ID_DOKUMENTU, ID_PARENT,  POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4, ID_ZADANIA, ZOBOWIAZANIE ) values
         (:ID, :ID_DOKUMENTU, :ID_PARENT,  2, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA, :ZOBOWIAZANIE);

    end

    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA,
    sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and sp.KOD='REALIZACJA' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end



    /* Wstawia zobowiazanie i realizacje do poziomu zaangazowania */
    for select rp.ID_PARENT,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
    sum(rp.ZOBOWIAZANIE) as ZOBOWIAZANIE,   sum(rp.REALIZACJA) as REALIZACJA
    from  FK_RAPORT rp where rp.POZIOM=2 and rp.ID =:ID
    group by  rp.ID_PARENT, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA
    into  :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZOBOWIAZANIE, :REALIZACJA
    do
    begin
        update FK_RAPORT set  ZOBOWIAZANIE= :ZOBOWIAZANIE, REALIZACJA=: REALIZACJA
        where  POZIOM=1 and ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end

    /*Usuwanie dodatkowych rekordw sumujcych*/
    delete from FK_RAPORT where ID=:ID and POZIOM=2;


    /*  Zwaraca ostateczne wyniki*/
    /*
	for select  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
	rp.ZAANGAZOWANIE, rp.ZOBOWIAZANIE, rp.REALIZACJA,
	sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sdok.ID_S_POZIOMY,
	sdok.CZY_SAMODZIELNY, sp.KOD as POZIOM, zad.TYP_PG as TYP_PG
	from  FK_RAPORT rp
	join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
	join (
		select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
		from FK_DOKUMENTY d
		join FK_S_STATUSY s on d.STATUS = s.ID
		where s.CZY_USUNIETY = 'N'
		and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
		and d.DATA_DOK >= :DATAOD
		and d.DATA_DOK <= :DATADO
		group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
	join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
	join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
	left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
	left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
	left join PB_ZADANIA zad on (rp.ID_ZADANIA = zad.ID_ZADANIA)
	where rp.POZIOM=1 and rp.ID =:ID and
	(:DATADO between zad.DATAH_OD and zad.DATAH_DO) and zad.ID_UCHWALY >= 0
	order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
	into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,
	:ZAANGAZOWANIE, :ZOBOWIAZANIE, :REALIZACJA,:TYP, :PODTYP, :KONTRAHENT, :ID_S_POZIOMY,
	:CZY_SAMODZIELNY, :POZIOM, :TYP_PG
	do
	begin
		suspend;
	end
    */

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT SELECT,INSERT,DELETE,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP TO SYSDBA;


/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE CLEAN_RAPORT (
    id integer)
as
begin
    /*Czysci tabele raportw*/
    if (:ID<>0) then delete from FK_RAPORT where ID=:ID;
    else
    delete from FK_RAPORT;

end^

SET TERM ; ^

GRANT SELECT,DELETE ON FK_RAPORT TO PROCEDURE CLEAN_RAPORT;

GRANT EXECUTE ON PROCEDURE CLEAN_RAPORT TO SYSDBA;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE WYDRUK_RB28 (
    id integer,
    rokb varchar(4),
    dataod date,
    datado date,
    id_jb integer,
    typ_jb varchar(250))
returns (
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    budzet double precision,
    zaangazowanie double precision,
    realizacja double precision,
    jest_zaangazowanie char(1))
as
declare variable poziom varchar(15);
begin
  /* Plan budzetowy */
   for select jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4,sum(jp.WARTOSC) as BUDZET
   from
   PB_UCHWALY u
   join PB_BUDZET_J bj on (bj.ID_UCHWALY = u.ID_UCHWALY and bj.STATUS in (0, 9))
   join PB_BUDZET_J_POZ jp on (bj.IDSPRAW = jp.IDSPRAW)
   where
   u.DATA_UOD<=:DATADO and u.ROKB=:ROKB and
   (bj.ID_JB = :ID_JB or bj.ID_JB in (select ID_JB
   from GET_JB_FROM_TYP (:TYP_JB) ))
   and  jp.WARTOSC<>0
   and jp.PRZEPLYW='W'
   group by jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4
   order by jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4
   into
      :DZIAL, :ROZDZIAL,:PAR, :PAR4, :BUDZET
   do
   begin
         insert into FK_RAPORT(ID, DZIAL, ROZDZIAL,  PAR, PAR4,  BUDZET, JEST_ZAANGAZOWANIE ) values
         (:ID,:DZIAL, :ROZDZIAL,  :PAR, :PAR4,  :BUDZET, 'N' );
   end

   /*Zaangazowanie */
   for select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as ZAANGAZOWANIE
   from FK_DEKRETACJA dekr
   join FK_TERMINY ter on (dekr.ID_TERMINY = ter.ID)
   join FK_DOKUMENTY dok on (dok.ID=ter.ID_DOKUMENTY)
   join FK_S_DOKUMENTY sdok on (dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma')
   join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and s.CZY_ZATWIERDZONY='T'
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
   join FK_S_STATUSY sta
   on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
   where extract(year from dok.DATA_DOK) = cast( :ROKB as Integer)  and
   extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
   (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB) )) and
   dok.DATA_DOK >= :DATAOD and
   dok.DATA_DOK <= :DATADO
   group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4
   into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:ZAANGAZOWANIE
   do
   begin
        update FK_RAPORT set ZAANGAZOWANIE=:ZAANGAZOWANIE,  JEST_ZAANGAZOWANIE= 'T'
        where  ID=:ID and  DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and  PAR=:PAR and PAR4=:PAR4;
   end

   /*Realizacja*/
   for select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as REALIZACJA,
   sp.KOD as POZIOM
   from FK_DEKRETACJA dekr
   join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
   join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
   join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
   join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and s.CZY_ZATWIERDZONY='T'
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
   join FK_S_POZIOMY sp on (sdok.ID_S_POZIOMY=sp.ID and sp.KOD='REALIZACJA')
   join FK_S_STATUSY sta
   on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
   where extract(year from dok.DATA_DOK) = cast (:ROKB as Integer)  and
   extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
   (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB) )) and
   dok.DATA_DOK >= :DATAOD and
   dok.DATA_DOK <= :DATADO
   group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sp.KOD
   into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:REALIZACJA,:POZIOM
   do
   begin
        update FK_RAPORT set  REALIZACJA=:REALIZACJA,  JEST_ZAANGAZOWANIE= 'T'
        where  ID=:ID and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and  PAR=:PAR and PAR4=:PAR4;
   end
   
   /* Wyswietlenie wynikow */
   for select r.DZIAL, r.ROZDZIAL, r.PAR, r.PAR4, r.BUDZET, r.ZAANGAZOWANIE, r.REALIZACJA,
   r.JEST_ZAANGAZOWANIE from FK_RAPORT r where r.ID=:ID
   into :DZIAL, :ROZDZIAL, :PAR, :PAR4, :BUDZET, :ZAANGAZOWANIE, :REALIZACJA, :JEST_ZAANGAZOWANIE
   do
   begin
      suspend;
   end


end^

SET TERM ; ^

GRANT SELECT ON PB_UCHWALY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON PB_BUDZET_J TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON PB_BUDZET_J_POZ TO PROCEDURE WYDRUK_RB28;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE WYDRUK_RB28;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_TERMINY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE WYDRUK_RB28;

GRANT EXECUTE ON PROCEDURE WYDRUK_RB28 TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANGAZOWANIE;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    zaangazowanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA,  :ZAANGAZOWANIE);
    end

    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA,
    sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end

    /*  Zwaraca ostateczne wyniki*/
    /*
	for select  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
	rp.ZAANGAZOWANIE, rp.REALIZACJA,
	sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY, sp.KOD as POZIOM
	from  FK_RAPORT rp
	join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
	join (
		select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
		from FK_DOKUMENTY d
		join FK_S_STATUSY s on d.STATUS = s.ID
		where s.CZY_USUNIETY = 'N'
		and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
		and d.DATA_DOK >= :DATAOD
		and d.DATA_DOK <= :DATADO
		group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
	join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
	join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
	left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
	left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
	where rp.POZIOM=1 and rp.ID =:ID
	order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
	into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,
	:ZAANGAZOWANIE, :REALIZACJA,:TYP, :PODTYP, :KONTRAHENT, :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM
	do
	begin
		suspend;
	end
    */

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANGAZOWANIE_DRP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE_DRP (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    zaangazowanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/


    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL,  PAR, PAR4,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4,  :ZAANGAZOWANIE);
    end



    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and PAR=:PAR and PAR4=:PAR4;
    end

    /*  Zwaraca ostateczne wyniki*/
    /*
	for select  dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4,
	rp.ZAANGAZOWANIE, rp.REALIZACJA,
	sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sdok.ID_S_POZIOMY, sdok.CZY_SAMODZIELNY, sp.KOD as POZIOM
	from  FK_RAPORT rp
	join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
	join (
	select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
		from FK_DOKUMENTY d
		join FK_S_STATUSY s on d.STATUS = s.ID
		where s.CZY_USUNIETY = 'N'
		and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
		and d.DATA_DOK >= :DATAOD
		and d.DATA_DOK <= :DATADO
		group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
	join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
	join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
	left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
	left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
	where rp.POZIOM=1 and rp.ID =:ID
	order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
	into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4,
	ZAANGAZOWANIE, :REALIZACJA,:TYP, :PODTYP, :KONTRAHENT, :ID_S_POZIOMY, :CZY_SAMODZIELNY, :POZIOM
	do
	begin
		suspend;
	end
   */

    
end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_DRP;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_DRP TO SYSDBA;

/*--------------------------------------------------------------- */

DROP PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE GET_ZAANGAZOWANIE_DRP_GP (
    id integer,
    dataod date,
    datado date,
    typ_jb varchar(250),
    id_jb integer,
    rok integer,
    czy_zatw smallint)
returns (
    id_parent integer,
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    id_zadania integer,
    zaangazowanie double precision,
    realizacja double precision,
    data_dok date,
    numer varchar(250),
    typ varchar(250),
    podtyp varchar(250),
    kontrahent varchar(25),
    id_s_poziomy integer,
    poziom varchar(15),
    czy_samodzielny varchar(1),
    typ_pg varchar(1))
as
declare variable id_dokumentu integer;
begin
    /* Zaangazowanie*/
    for
    select  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA,
    sum(dekr.KWOTA) as ZAANGAZOWANIE
    from FK_DEKRETACJA dekr
    join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
    join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
    join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma'
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
      and d.DATA_DOK >= :DATAOD
      and d.DATA_DOK <= :DATADO
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
    join FK_S_STATUSY sta
    on  (sta.ID=dok.STATUS)
    where extract(year from dok.DATA_DOK) = :ROK and
    extract(year from ter.TERMIN) =:ROK and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)  ))
    group by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA
    order by  dok.ID_PIERWOTNY, dekr.DZIAL, dekr.ROZDZIAL, dekr.PAR, dekr.PAR4, dekr.ID_ZADANIA

    into  :ID_DOKUMENTU, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :ZAANGAZOWANIE
    do
    begin
      insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, DZIAL, ROZDZIAL, PAR, PAR4, ID_ZADANIA,  ZAANGAZOWANIE ) values
         (:ID, :ID_DOKUMENTU, 1, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :ID_ZADANIA,  :ZAANGAZOWANIE);
    end

    /*Realizacja*/
    for select rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA,
    sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
    join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
    join FK_DOKUMENTY dok on (rt.ID_DOKUMENTY = dok.ID)
    join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
    join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N'
    and (sta.CZY_ZATWIERDZONY='T' or (:CZY_ZATW=0)))
    join FK_S_DOKUMENTY sdok on   rdok.ID_S_DOKUMENTY = sdok.ID
    join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
    join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=rdok.ID_PIERWOTNY and WER=rdok.WERSJA)
    where  extract(year from rt.TERMIN) =:ROK and sp.KOD='ZOBOWIAZANIE' and
    (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB)))
    group by  rdok.ID_PARENT, rdk.DZIAL, rdk.ROZDZIAL, rdk.PAR, rdk.PAR4, rdk.ID_ZADANIA
    into :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA, :REALIZACJA
    do
    begin

        update FK_RAPORT set  REALIZACJA=:REALIZACJA
        where  ID=:ID and ID_DOKUMENTU=:ID_PARENT and DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL
        and PAR=:PAR and PAR4=:PAR4 and ID_ZADANIA=:ID_ZADANIA;
    end

    /*  Zwaraca ostateczne wyniki*/
    /*
	for select dok.NUMER, dok.DATA_DOK, rp.ID_DOKUMENTU ,  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.ID_ZADANIA,
	rp.ZAANGAZOWANIE, rp.REALIZACJA,
	sdok.NAZWA as TYP, pdt.NAZWA as PODTYP, vk.SKROT as KONTRAHENT, sdok.ID_S_POZIOMY,
	sdok.CZY_SAMODZIELNY, sp.KOD as POZIOM, zad.TYP_PG as TYP_PG
	from  FK_RAPORT rp
	join FK_DOKUMENTY dok on (rp.ID_DOKUMENTU=dok.ID_PIERWOTNY)
	join (
		select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
		from FK_DOKUMENTY d
		join FK_S_STATUSY s on d.STATUS = s.ID
		where s.CZY_USUNIETY = 'N'
		and (s.CZY_ZATWIERDZONY='T' or :CZY_ZATW=0)
		and d.DATA_DOK >= :DATAOD
		and d.DATA_DOK <= :DATADO
		group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
	join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
	join FK_S_POZIOMY sp on sdok.ID_S_POZIOMY=sp.ID
	left join V_KONTRAHENCI vk on (vk.ID=dok.ID_KONTRAHENCI)
	left join FK_S_PODTYPY pdt on (dok.ID_S_PODTYPY=pdt.ID)
	left join PB_ZADANIA zad on (rp.ID_ZADANIA = zad.ID_ZADANIA)
	where rp.POZIOM=1 and rp.ID =:ID and
	:DATADO between zad.DATAH_OD and zad.DATAH_DO) and zad.ID_UCHWALY >= 0
	order by  rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4
	into  :NUMER, :DATA_DOK, :ID_PARENT, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :ID_ZADANIA,
	:ZAANGAZOWANIE, :REALIZACJA,:TYP, :PODTYP, :KONTRAHENT, :ID_S_POZIOMY,
	:CZY_SAMODZIELNY, :POZIOM, :TYP_PG
	do
	begin
		suspend;
	end
    */

end^

SET TERM ; ^

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_TERMINY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_DRP_GP TO SYSDBA;


/*--------------------------------------------------------------- */








