DROP PROCEDURE WYDRUK_UMOWY;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE WYDRUK_UMOWY (
    data date,
    id_dok integer,
    rok integer)
returns (
    id integer,
    numer varchar(250),
    data_dok date,
    nazwa varchar(250),
    dzial char(3),
    rozdzial char(5),
    par char(3),
    par4 char(1),
    zadanie varchar(250),
    id_zadania integer,
    zaangazowanie double precision,
    zobowiazanie double precision,
    realizacja double precision,
    poziom integer,
    id_pierwotny integer)
as
declare variable id_wyzej integer;
declare variable sum_realizacja double precision;
declare variable czesc_realizacja double precision;
begin
  /* Procedure Text */
  for select u.ID,u.ID_PIERWOTNY,u.NUMER,u.DATA_DOK,u.NAZWA,u.POZIOM  from GET_UMOWY(:ID_DOK,1) u
  into :ID,:ID_PIERWOTNY,:NUMER,:DATA_DOK,:NAZWA,:POZIOM
  do
  begin
    for select dk.DZIAL,dk.ROZDZIAL,dk.PAR,dk.PAR4,dk.ID_ZADANIA,z.NAZWA,
    dk.KWOTA as ZAANGAZOWANIE from FK_DEKRETACJA dk
    join FK_TERMINY t on (t.ID=dk.ID_TERMINY)
    join PB_ZADANIA z on (dk.ID_ZADANIA=z.ID_ZADANIA)
    where  t.ID_DOKUMENTY=:ID and extract(year from t.TERMIN) =:ROK
    and  (:DATA between z.DATAH_OD and z.DATAH_DO)
    order by dk.DZIAL,dk.ROZDZIAL,dk.PAR,dk.PAR4,dk.ID_ZADANIA
    into
    :DZIAL, :ROZDZIAL, :PAR, :PAR4,:ID_ZADANIA, :ZADANIE, :ZAANGAZOWANIE
    do
    begin
       select sum(rdk.KWOTA) as ZOBOWIAZANIE from FK_DOKUMENTY  rdok
       join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
       join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
       inner join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N')
       where rdok.ID_PARENT=:ID_PIERWOTNY
       and extract(year from rt.TERMIN) =:ROK
       and rdok.OSTATNI_NIEUSUNIETY=1
       and rdk.DZIAL=:DZIAL
       and rdk.ROZDZIAL=:ROZDZIAL
       and rdk.PAR=:PAR
       and rdk.PAR4=:PAR4
       and rdk.ID_ZADANIA=:ID_ZADANIA
       into :ZOBOWIAZANIE;

       SUM_REALIZACJA=0;
       CZESC_REALIZACJA=0;

       for select distinct rdok.ID_PIERWOTNY from FK_DOKUMENTY  rdok
       join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
       join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
       inner join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N')
       where rdok.ID_PARENT=:ID_PIERWOTNY and extract(year from rt.TERMIN) =:ROK
       and rdok.OSTATNI_NIEUSUNIETY=1
       and rdk.DZIAL=:DZIAL
       and rdk.ROZDZIAL=:ROZDZIAL
       and rdk.PAR=:PAR
       and rdk.PAR4=:PAR4
       and rdk.ID_ZADANIA=:ID_ZADANIA
       into :ID_WYZEJ
       do
       begin
           select sum(rdk.KWOTA) from FK_DOKUMENTY  rdok
           join FK_TERMINY rt on (rdok.ID=rt.ID_DOKUMENTY)
           join FK_DEKRETACJA rdk on (rdk.ID_TERMINY =rt.ID)
           inner join FK_S_STATUSY sta on  (sta.ID=rdok.STATUS  and sta.CZY_USUNIETY='N')
           where rdok.ID_PARENT=:ID_WYZEJ and extract(year from rt.TERMIN) =:ROK
           and rdok.OSTATNI_NIEUSUNIETY=1
           and rdk.DZIAL=:DZIAL
           and rdk.ROZDZIAL=:ROZDZIAL
           and rdk.PAR=:PAR
           and rdk.PAR4=:PAR4
           and rdk.ID_ZADANIA=:ID_ZADANIA
           into :CZESC_REALIZACJA;

           if (:CZESC_REALIZACJA is null) then CZESC_REALIZACJA=0;

           SUM_REALIZACJA=:CZESC_REALIZACJA+:SUM_REALIZACJA;

       end

       REALIZACJA=:SUM_REALIZACJA;

       suspend;
    end

  end



end^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE GET_UMOWY TO PROCEDURE WYDRUK_UMOWY;

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE WYDRUK_UMOWY;

GRANT SELECT ON FK_TERMINY TO PROCEDURE WYDRUK_UMOWY;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE WYDRUK_UMOWY;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE WYDRUK_UMOWY;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE WYDRUK_UMOWY;

GRANT EXECUTE ON PROCEDURE WYDRUK_UMOWY TO SYSDBA;


/*--------------------------------------------------------------- */